#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <fstream.h>



SoPerspectiveCamera *
makeAliveCamera( char* name )
{
  SoPerspectiveCamera *camera = new SoPerspectiveCamera;
  
  float sx;
  float sy;
  float dp[3];
  float mat[3][3];
  float ha;
  float sc;
  // (1) READ FILE
  ifstream file( name );
  if( !file )
    fprintf( stderr, "camera read failed  \n" );
  file >> sx;				// screen dimensions
  file >> sy;
  for( int j = 0; j < 3; j++ )	// position of camera
    file >> dp[j];
  for( int i = 0; i < 3; i++ )	// rotation matrix
    for( j = 0; j < 3; j++ )
      file >> mat[i][j];
  file >> ha;				// height angle
  file >> sc;				// scale
  file.close();
  // (2) ADJUST CAMERA
  SbMatrix rm(mat[0][0], mat[0][1], mat[0][2], 0, 
	      mat[1][0], mat[1][1], mat[1][2], 0,
	      mat[2][0], mat[2][1], mat[2][2], 0,
	      0, 0, 0, 1);
  SbVec3f disp( dp[0], dp[1], dp[2] ); 
  disp /= sc;
  camera -> aspectRatio.setValue( SO_ASPECT_VIDEO );
  camera -> viewportMapping.setValue( SoCamera::CROP_VIEWPORT_FILL_FRAME );
  camera -> position.setValue( disp );
  camera -> orientation.setValue( SbRotation( rm ) );
  camera -> nearDistance = 1.;
  camera -> farDistance  = 1000.;

  camera -> heightAngle = ha;
  return camera;
}
